/* RGB COLOUR CODE GENERATOR BY A. SAMIUDDHIN */
#include <LiquidCrystal.h> // LCD library
LiquidCrystal lcd(7, 6, 5, 4, 3, 2); //LCD diplay pins on Arduino
int Radj;
int Gadj;
int Badj;
int Rval=0;
int Gval=0;
int Bval=0;
int R = 9;
int G = 10;
int B = 11;
void setup() {
pinMode(R, OUTPUT); // Pin 9 declared as output
pinMode(G, OUTPUT); // Pin 10 declared as output
pinMode(B, OUTPUT); // Pin 11 declared as output
lcd.begin(16,2); // Initialise LCD
delay(1);
lcd.setCursor(0,0);
lcd.print("RGB COLOUR CODE");
lcd.setCursor(4,1);
lcd.print("GENERATOR");
delay(2000);
lcd.setCursor(0, 0);
lcd.print(" R    G    B   ");
lcd.setCursor(3,1);
lcd.print("HEX=      ");
}

void loop() {
Radj = analogRead(0);
Gadj = analogRead(1);
Badj = analogRead(2);
Rval=Radj/4; // Convert the range from (0-1023) to (0-255)
Gval=Gadj/4; // Convert the range from (0-1023) to (0-255)
Bval=Badj/4; // Convert the range from (0-1023) to (0-255)
lcd.setCursor(2,0);
if (Rval<10)
{
lcd.setCursor(2,0);
lcd.print("00");
lcd.print(Rval);
}
else if(Rval<100)
{
lcd.setCursor(2,0);
lcd.print("0");
lcd.print(Rval);
}
else
{
lcd.setCursor(2,0);
lcd.print(Rval);
}
lcd.setCursor(8,1);
if (Rval<16)
{
lcd.print("0");
lcd.print(Rval, 16);
}
else
{
lcd.print(Rval, 16);
}
lcd.setCursor(7,0);
if (Gval<10)
{
lcd.setCursor(7,0);
lcd.print("00");
lcd.print(Gval);
}
else if(Gval<100)
{
lcd.setCursor(7,0);
lcd.print("0");
lcd.print(Gval);
}
else
{
lcd.setCursor(7,0);
lcd.print(Gval);
}
lcd.setCursor(10,1);
if (Gval<16)
{
lcd.print("0");
lcd.print(Gval, 16);
}
else
{
lcd.print(Gval, 16);
}
lcd.setCursor(12,0);
if (Bval<10)
{
lcd.setCursor(12,0);
lcd.print("00");
lcd.print(Bval);
}
else if(Bval<100)
{
lcd.setCursor(12,0);
lcd.print("0");
lcd.print(Bval);
}
else
{
lcd.setCursor(12,0);
lcd.print(Bval);
}
lcd.setCursor(12,1);
if (Bval<16)
{
lcd.print("0");
lcd.print(Bval, 16);
}
else
{
lcd.print(Bval, 16);
}
analogWrite(R, Rval); // PWM for Red colour
analogWrite(G, Gval); // PWM for Green colour
analogWrite(B, Bval); // PWM for Blue colour
}
